/* This is packet-wsp-headers.h
 * Automagically generated with wsp_headers.def as input
 *
 * Created on Wed Mar 14 21:54:17 CET 2001.
 */

/* The WSP headers are uniquely identified with the following integer
 * mapping.  This mapping allows immediate retrieval of the given string
 * when the (unique) index is known.
 * In the WSP standard, some headers have been reassigned a new number,
 * resulting in a set of duplicate headers.
 * Also, some badly encoded headers have been added (like X-Wap-Tod, which
 * is sometimes encoded as "X-WAP.TOD" (note the period instead of the dash)).
 */
#define WSP_HDR_ACCEPT                      	0
#define WSP_HDR_ACCEPT_APPLICATION          	50
#define WSP_HDR_ACCEPT_CHARSET              	1
#define WSP_HDR_ACCEPT_ENCODING             	2
#define WSP_HDR_ACCEPT_LANGUAGE             	3
#define WSP_HDR_ACCEPT_RANGES               	4
#define WSP_HDR_AGE                         	5
#define WSP_HDR_ALLOW                       	6
#define WSP_HDR_AUTHORIZATION               	7
#define WSP_HDR_BEARER_INDICATION           	51
#define WSP_HDR_CACHE_CONTROL               	8
#define WSP_HDR_CONNECTION                  	9
#define WSP_HDR_CONTENT_BASE                	10
#define WSP_HDR_CONTENT_DISPOSITION         	46
#define WSP_HDR_CONTENT_ENCODING            	11
#define WSP_HDR_CONTENT_ID                  	64
#define WSP_HDR_CONTENT_LANGUAGE            	12
#define WSP_HDR_CONTENT_LENGTH              	13
#define WSP_HDR_CONTENT_LOCATION            	14
#define WSP_HDR_CONTENT_MD5                 	15
#define WSP_HDR_CONTENT_RANGE               	16
#define WSP_HDR_CONTENT_TYPE                	17
#define WSP_HDR_COOKIE                      	66
#define WSP_HDR_DATE                        	18
#define WSP_HDR_ENCODING_VERSION            	67
#define WSP_HDR_ETAG                        	19
#define WSP_HDR_EXPECT                      	56
#define WSP_HDR_EXPIRES                     	20
#define WSP_HDR_FROM                        	21
#define WSP_HDR_HOST                        	22
#define WSP_HDR_IF_MATCH                    	24
#define WSP_HDR_IF_MODIFIED_SINCE           	23
#define WSP_HDR_IF_NONE_MATCH               	25
#define WSP_HDR_IF_RANGE                    	26
#define WSP_HDR_IF_UNMODIFIED_SINCE         	27
#define WSP_HDR_LAST_MODIFIED               	29
#define WSP_HDR_LOCATION                    	28
#define WSP_HDR_MAX_FORWARDS                	30
#define WSP_HDR_PRAGMA                      	31
#define WSP_HDR_PROFILE                     	53
#define WSP_HDR_PROFILE_DIFF                	54
#define WSP_HDR_PROFILE_WARNING             	55
#define WSP_HDR_PROXY_AUTHENTICATE          	32
#define WSP_HDR_PROXY_AUTHORIZATION         	33
#define WSP_HDR_PUBLIC                      	34
#define WSP_HDR_PUSH_FLAG                   	52
#define WSP_HDR_RANGE                       	35
#define WSP_HDR_REFERER                     	36
#define WSP_HDR_RETRY_AFTER                 	37
#define WSP_HDR_SERVER                      	38
#define WSP_HDR_SET_COOKIE                  	65
#define WSP_HDR_TE                          	57
#define WSP_HDR_TRAILER                     	58
#define WSP_HDR_TRANSFER_ENCODING           	39
#define WSP_HDR_UPGRADE                     	40
#define WSP_HDR_USER_AGENT                  	41
#define WSP_HDR_VARY                        	42
#define WSP_HDR_VIA                         	43
#define WSP_HDR_WARNING                     	44
#define WSP_HDR_WWW_AUTHENTICATE            	45
#define WSP_HDR_X_WAP_APPLICATION_ID        	47
#define WSP_HDR_X_WAP_CONTENT_URI           	48
#define WSP_HDR_X_WAP_INITIATOR_URI         	49
#define WSP_HDR_X_WAP_TOD                   	63

/*
 * The actual hashing code starts here.
 */
/* ANSI-C code produced by gperf version 2.7.1 (19981006 egcs) */
/* Command-line: gperf -LANSI-C -TDCIEctol -H wsp_hdr_hash -N wsp_hdr_in_word_set -K strptr -k 1,$ wsp_headers.gperf.in.tmp  */
#include <string.h>
/* maximum key range = 91, duplicates = 3 */

#ifdef __GNUC__
__inline
#endif
static unsigned int
wsp_hdr_hash (register const char *str, register unsigned int len)
{
  static const unsigned char asso_values[] =
    {
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 15, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93,  5,  0, 10,  5,  0,
      20, 30, 55, 10, 93, 93, 25,  0, 15, 93,
      35, 93,  5, 50,  0, 30,  5, 55, 56,  5,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93, 93, 93, 93, 93,
      93, 93, 93, 93, 93, 93
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
static guint8
get_wsp_hdr_id (register const char *str, register unsigned int len)
{
  enum
    {
      TOTAL_KEYWORDS = 65,
      MIN_WORD_LENGTH = 2,
      MAX_WORD_LENGTH = 20,
      MIN_HASH_VALUE = 2,
      MAX_HASH_VALUE = 92
    };

  static const unsigned char lengthtable[] =
    {
       2,  6,  3,  4,  5,  6,  7,  3,  4,  6,  7,  8, 14, 15,
      11, 12, 12, 13,  4, 10, 16, 17, 19, 16, 17, 13,  4, 10,
      11,  7, 18, 10, 16,  7, 13, 19,  6, 17,  8, 13, 15,  6,
      18, 16,  7,  4, 10,  6, 12,  5, 12, 13, 19,  9,  9, 16,
       8,  9, 13, 14, 15, 20, 17, 19,  7
    };
  static const value_string wordlist[] =
    {
      { 57, "TE" },
      { 56, "EXPECT" },
      { 5, "AGE" },
      { 18, "DATE" },
      { 35, "RANGE" },
      { 0, "ACCEPT" },
      { 58, "TRAILER" },
      { 43, "VIA" },
      { 42, "VARY" },
      { 66, "COOKIE" },
      { 36, "REFERER" },
      { 26, "IF-RANGE" },
      { 1, "ACCEPT-CHARSET" },
      { 3, "ACCEPT-LANGUAGE" },
      { 37, "RETRY-AFTER" },
      { 10, "CONTENT-BASE" },
      { 17, "CONTENT-TYPE" },
      { 16, "CONTENT-RANGE" },
      { 21, "FROM" },
      { 64, "CONTENT-ID" },
      { 12, "CONTENT-LANGUAGE" },
      { 23, "IF-MODIFIED-SINCE" },
      { 27, "IF-UNMODIFIED-SINCE" },
      { 67, "ENCODING-VERSION" },
      { 51, "BEARER-INDICATION" },
      { 7, "AUTHORIZATION" },
      { 19, "ETAG" },
      { 9, "CONNECTION" },
      { 15, "CONTENT-MD5" },
      { 40, "UPGRADE" },
      { 50, "ACCEPT-APPLICATION" },
      { 41, "USER-AGENT" },
      { 14, "CONTENT-LOCATION" },
      { 53, "PROFILE" },
      { 29, "LAST-MODIFIED" },
      { 46, "CONTENT-DISPOSITION" },
      { 31, "PRAGMA" },
      { 39, "TRANSFER-ENCODING" },
      { 28, "LOCATION" },
      { 8, "CACHE-CONTROL" },
      { 2, "ACCEPT-ENCODING" },
      { 34, "PUBLIC" },
      { 32, "PROXY-AUTHENTICATE" },
      { 11, "CONTENT-ENCODING" },
      { 20, "EXPIRES" },
      { 22, "HOST" },
      { 65, "SET-COOKIE" },
      { 38, "SERVER" },
      { 30, "MAX-FORWARDS" },
      { 6, "ALLOW" },
      { 54, "PROFILE-DIFF" },
      { 4, "ACCEPT-RANGES" },
      { 33, "PROXY-AUTHORIZATION" },
      { 63, "X-WAP-TOD" },
      { 63, "X-WAP.TOD" },
      { 45, "WWW-AUTHENTICATE" },
      { 24, "IF-MATCH" },
      { 52, "PUSH-FLAG" },
      { 25, "IF-NONE-MATCH" },
      { 13, "CONTENT-LENGTH" },
      { 55, "PROFILE-WARNING" },
      { 47, "X-WAP-APPLICATION-ID" },
      { 48, "X-WAP-CONTENT-URI" },
      { 49, "X-WAP-INITIATOR-URI" },
      { 44, "WARNING" }
    };

  static const short lookup[] =
    {
        -1,   -1,    0,   -1,   -1,   -1,    1,   -1,
         2,    3,    4,    5,    6,    7,    8,   -1,
         9,   10,   11,   12,   13,   14, -129,   17,
        18,   19,   20,   21,   -1,   22,   -1,   23,
        24,   25,   26,   27,   28,   29,   30,   -1,
        31,   32,   33,   34,   35,   -1,   36,   37,
      -120,   -1,   40,   41,   -1,   42,  -27,   -2,
        43,   44,   -1,   45,   46,   47,   48,  -50,
        -2,   49,   -1,   50,   51,   52, -141,   55,
        -1,   56,   57,  -12,   -2,   -1,   58,   59,
        60,   61,   -1,   62,   -1,   63,   -1,   -1,
        -1,   -1,   -1,   -1,   64
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = wsp_hdr_hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register int index = lookup[key];

          if (index >= 0)
            {
              if (len == lengthtable[index])
                {
                  register const char *s = wordlist[index].strptr;

                  if (*str == *s && !strncmp (str + 1, s + 1, len - 1))
                    return (wordlist[index]).value;
                }
            }
          else if (index < -TOTAL_KEYWORDS)
            {
              register int offset = - 1 - TOTAL_KEYWORDS - index;
              register const unsigned char *lengthptr = &lengthtable[TOTAL_KEYWORDS + lookup[offset]];
              register const value_string *wordptr = &wordlist[TOTAL_KEYWORDS + lookup[offset]];
              register const value_string *wordendptr = wordptr + -lookup[offset + 1];

              while (wordptr < wordendptr)
                {
                  if (len == *lengthptr)
                    {
                      register const char *s = wordptr->strptr;

                      if (*str == *s && !strncmp (str + 1, s + 1, len - 1))
                        return wordptr->value;
                    }
                  lengthptr++;
                  wordptr++;
                }
            }
        }
    }
  return 0xFF; /* Not in WSP word list */
}
